<?php
namespace Teknisa\PLA\Modules\Mymenu\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Mym00109AnalisePesquisaSatisfacaoController extends \Zeedhi\Framework\Controller\Report {

    protected $reportName;
    protected $crudService;
    protected $nrorg;
    protected $birtStrategy;
    protected $nrlista;
    protected $mym00109AnalisePesquisaSatisfacaoService;

    public function __construct(ReportService $reportService,$crudService, $birtStrategy ,$mym00109AnalisePesquisaSatisfacaoService) {
        $this->crudService = $crudService;
        $this->birtStrategy = $birtStrategy;
        $this->mym00109AnalisePesquisaSatisfacaoService = $mym00109AnalisePesquisaSatisfacaoService;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'MYM00100' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "NRLISTA"          =>"NRLISTA",
              "NRQUESTIONARIO"   =>"NRQUESTIONARIO",
              "IDAPLICATIVO"     =>"IDAPLICATIVO",
              "DTINICIO"         =>"DTINICIO",
              "DTFIM"            =>"DTFFIM"
            )
        )
    );


    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'];
        $row["LISTAFILIAL"] = '';

        $listaFilial = $this->geraListaFilial($row['CDGRUPFILI'],$row['TODOSFILIAL'],$row);
        
        $this->nrlista = $this->mym00109AnalisePesquisaSatisfacaoService->geraLista($this->nrorg, $listaFilial, '_');
        $row['NRLISTA'] = $this->nrlista;
        $row['NRQUESTIONARIO'] = $row['QUESTIONARIO'];
        $row['IDAPLICATIVO'] = $row['APLICATIVO'];
    }
    
    public function geraListaFilial($agrupamento ,$todos,$row){
        if(empty($agrupamento) && $todos === 'S' ){
            $conditions = array(
                array(
                    "columnName" => "CDOPERADOR",
                    "operator" => "=",
                    "value" => $this->crudService->getEnvironment()->getCdOperador()
                ),
                array(
                    "columnName" => "NRORG",
                    "operator" => "=",
                    "value" => $this->crudService->getEnvironment()->getNrOrg()
                ),
                array(
                    "columnName" => "CDGRUPFILI",
                    "operator" => "=",
                    "value" => 'T'
                )
            );
            $resultFilais = $this->crudService->getFilteredDataSet('filial_operador_grupfili', $conditions)->getRows();
            
            $contador = count($resultFilais);
            
            $this->concatFilial($row,$resultFilais);
        }
        else if(empty($agrupamento) && $todos === 'N' ){
            $row["LISTAFILIAL"] = $row["CDFILIAL"];
        }
        if(!empty($agrupamento) && $todos === 'S'){
             $conditions = array(
                array(
                    "columnName" => "CDGRUPFILI",
                    "operator" => "=",
                    "value" => $row['CDGRUPFILI']
                ),
                array(
                    "columnName" => "NRORG",
                    "operator" => "=",
                    "value" => $this->crudService->getEnvironment()->getNrOrg()
                )
            );
            $resultFilais = $this->crudService->getFilteredDataSet('filial_operador_grupfili', $conditions)->getRows();
            $contador = count($resultFilais);
            
            $this->concatFilial($row,$resultFilais);
        }
        else if(!empty($agrupamento) && $todos === 'N'){
             $row["LISTAFILIAL"] = $row["CDFILIAL"];
        }
        
        return $row["LISTAFILIAL"];
    }
    
    public function concatFilial($row,$resultadoFilial){
        for($i = 0; $i<count($resultadoFilial); $i++){
                $row["LISTAFILIAL"] .= $resultadoFilial[$i]['CDFILIAL'] . "_";
            }
        $row["LISTAFILIAL"] = trim($row["LISTAFILIAL"], '_');
    }
    
    
}
